#include<stdio.h>
#include<iostream>
#include<algorithm>
using namespace std;
int main()
{
	int n,m,q,*x,*y,p;
	long long *a[100000],*b[100000];
	cin>>n>>m;
	
	for(int i=0; i<n; i++) a[i]=(long long *)malloc(m*sizeof(long long));
	for(int i=0; i<n; i++) b[i]=(long long *)malloc(m*sizeof(long long));
	for(int i=0; i<n; i++)
		for(int j=0; j<m; j++) cin>>a[i][j];
		
	cin>>q;
	x=(int *)malloc((q+1)*sizeof(int));
	y=(int *)malloc((q+1)*sizeof(int));
	for(int i=0; i<q; i++)
	{
		cin>>x[i]>>y[i];
		x[i]--; y[i]--;
	}
	
	
	
	for(int k=0; k<q; k++)
	{
		p=a[x[k]][y[k]];
		a[x[k]][y[k]]=1000000000000;
		for(int i=0; i<n; i++)
			for(int j=0; j<m; j++)
			{
				b[i][j]=a[i][j];
				if((i==0 && j==0) ||  (i==x[k] && j==y[k])) continue;
				
				if(j==0) b[i][j]+=b[i-1][0];
				else if(i==0) b[i][j]+=b[0][j-1];
				else b[i][j]+=min(b[i-1][j],b[i][j-1]);
			}
			
		cout<<b[n-1][m-1]<<endl;
		a[x[k]][y[k]]=p;
	}
	
	return 0;
}